"""
Filename: time.py
Author: Mark Clarkson
Date: July, 2012
Description: A time calculator and converter
"""

#function to print the arithmetic menu and return the choice
def menuOne():
    menu = "\n\n====================\n\
Time Calculator - Arithmetic Mode\n\
1 - Add 2 times\n\
2 - Find the difference between 2 times\n\
8 - Conversion mode\n\
9 - Exit\n"
    
    while True: #repeat until a valid answer submitted
        print(menu)
        choice = int(input("Enter an option: "))
        if choice == 1 or choice == 2 or choice == 8 or choice == 9:
            return choice
        print("\n\nSorry, your response weas not recognised. Please try again.")

#function to print the conversion menu and return the choice
def menuTwo():
    menu = "\n\n====================\n\
Time Calculator - Conversion Mode\n\
1 - Convert Time to Days\n\
2 - Convert Time to Hours\n\
3 - Convert Time to Minutes\n\
4 - Convert Minutes to Time\n\
5 - Convert Hours to Time\n\
6 - Convert Days to Time\n\
8 - Arithmetic mode\n\
9 - Exit\n"
    while True: #repeat until a valid answer submitted
        print(menu)
        choice = int(input("Enter an option: "))
        if choice > 0 and choice < 7:
            return choice
        elif choice == 8 or choice == 9:
            return choice
        print("\n\nSorry, your response weas not recognised. Please try again.")

#function to get a time and return it in the format DD:HH:MM. Really this should have validation
def getTime():
    days = input("Please enter the number of days (leave blank for none) ")
    if days == "":
        days = 0
    else:
        days = int(days)
    hours = input("Please enter the number of hours (leave blank for none) ")
    if hours == "":
        hours = 0
    else:
        hours = int(hours)
    mins = input("Please enter the number of minutes (leave blank for none) ")
    if mins == "":
        mins = 0
    else:
        mins = int(mins)
    time = [days,hours,mins]
    return time

#function to add two times together in DD:HH:MM
def addTwoTimes():
    days = [0]*3 #declare a blank array with 3 values to store the answer
    print("Enter your first time.")
    time1 = getTime()
    print("Enter your second time.")
    time2 = getTime()

    days[2] = time1[2] + time2[2] #add the minutes together
    if days[2] > 60:    #if there are more then 60 minutes then carry over to hours
        days[1] = days[2] // 60
        days[2] = days[2] % 60
    
    days[1] = days[1] + time1[1] + time2[1] #add the hours together (including the carry)
    if days[1] > 24: #if there are more than 24 hours then carry over to days
        days[0] = days[1] // 24
        days[1] = days[1] % 24

    days[0] = days[0] + time1[0] + time2[0] #add the days together (including the carry)

    print(time1[0],"days",time1[1],"hours and",time1[2],"minutes\n   plus")
    print(time2[0],"days",time2[1],"hours and",time2[2],"minutes\n   equals")
    print(days[0],"days",days[1],"hours and",days[2],"minutes\n")

#function to subtract two times in DD:HH:MM
def diffTwoTimes():
    neg = False #boolean to state whether the answer is negative (second number bigger than the first
    days = [0]*3 #declare a blank array with 3 values to store the answer
    print("Enter your first time.")
    time1 = getTime()
    print("Enter your second time.")
    time2 = getTime()

    min1 = time1[0] + 24 * (time1[1] + 60 * time1[2]) #calculate total minutes in time 1
    min2 = time2[0] + 24 * (time2[1] + 60 * time2[2]) #caluclate total minutes in time 2
    if min2 > min1: #find out it second number is bigger. If so, swap over so result will always be positive
        time3 = [0]*3
        neg = True #record whether the subtraction is back to front
        for loopCounter in range(3):
            time3[loopCounter] = time2[loopCounter]
        for loopCounter in range(3):
            time2[loopCounter] = time1[loopCounter]
        for loopCounter in range(3):
            time1[loopCounter] = time3[loopCounter]
            

    days[2] = time1[2] - time2[2] #subtract minutes
    while days[2] < 0: #if result is negative, borrow (possibly more than once)
        days[1] = days[1] - 1
        days[2] = days[2] + 60
    
    days[1] = days[1] + time1[1] - time2[1] #subtract hours
    while days[1] < 0: #if result is negative, borrow (possibly more than once)
        days[0] = days[0] - 1
        days[1] = days[1] + 24

    days[0] = days[0] + time1[0] - time2[0] #subtract days. Should never be positive

    print(time1[0],"days",time1[1],"hours and",time1[2],"minutes\n   plus")
    print(time2[0],"days",time2[1],"hours and",time2[2],"minutes\n   equals")
    if neg: #if values were swapped, make it clear that the result is negative
        print("minus",days[0],"days",days[1],"hours and",days[2],"minutes\n")
    else:
        print(days[0],"days",days[1],"hours and",days[2],"minutes\n")
    
#procedure to convert from a time (DD:HH:MM) to a decimal fraction of days
def convertTimeDay():
    print("Enter your time.")
    time = getTime()
    days = time[0] + (time[1] + time[2]/60)/24
    print("\n\n",time[0],"days",time[1],"hours and",time[2],"minutes =",days,"days.")

#procedure to convert from a time (DD:HH:MM) to a decimal fraction of hours
def convertTimeHour():
    print("Enter your time.")
    time = getTime()
    hours = time[0] *24 + time[1] + time[2]/60
    print("\n\n",time[0],"days",time[1],"hours and",time[2],"minutes =",hours,"hours.")

#procedure to convert from a time (DD:HH:MM) to a decimal fraction of minutes
def convertTimeMin():
    print("Enter your time.")
    time = getTime()
    mins = (time[0] *24 + time[1]) * 60 + time[2]
    print("\n\n",time[0],"days",time[1],"hours and",time[2],"minutes =",mins,"minutes.")

#procedure to convert from a decimal fraction of minutes to a time (DD:HH:MM)
def convertMinTime():
    minsOrig = int(input("Enter a number of minutes.")) #record original input
    mins = minsOrig #use a different variable for calculations
    time = [0]*3 #declre a blank array of 3 elements to store the answer
    time[0] = mins // (24*60) #calculate number of days
    mins = mins % (24*60) #update number of minutes remaining
    time[1] = mins // 60 #calculate number of hours
    mins = mins % 60 #update number of minutes remianing
    time[2] = mins #add number of minutes remaining to answer
    print("\n\n",minsOrig,"minutes equals", time[0],"days",time[1],"hours",time[2],"minuntes.")

#procedure to convert from a decimal fraction of hours to a time (DD:HH:MM)
#basic method as convertMinTime() above
def convertHourTime():
    hoursOrig = float(input("Enter a number of hours."))
    hours = hoursOrig
    time = [0]*3
    time[0] = hours // 24
    hours = hours % 24
    time[1] = int(hours)
    time[2] = (hours - int(hours))*60
    print("\n\n",hoursOrig,"hours equals", time[0],"days",time[1],"hours",time[2],"minuntes.")

#procedure to convert from a decimal fraction of days to a time (DD:HH:MM)
#basic method as convertMinTime() above
def convertDayTime():
    daysOrig = float(input("Enter a number of days."))
    days = daysOrig
    time = [0]*3
    time[0] = int(days)
    days = days - int(days)
    days = 24*days #now really hours
    time[1] = int(days)
    days = days - int(days)
    days = days * 60 #now really minutes
    time[2] = days
    print("\n\n",daysOrig,"days equals", time[0],"days",time[1],"hours",time[2],"minuntes.")


            
        
#MAIN METHOD
mode = 1
while True: #repeat forever (until break)
    if mode == 1: #if in calculation mode
        option = menuOne()
        if option == 1:
            addTwoTimes()
        elif option == 2:
            diffTwoTimes()
        elif option == 8:
           mode = 2 #switch mode
        elif option == 9:
            break
    elif mode == 2: #if in conversion mode
        option = menuTwo()
        if option == 1:
             convertTimeDay()
        elif option == 2:
             convertTimeHour()
        elif option == 3:
            convertTimeMin()
        elif option == 4:
            convertMinTime()
        elif option == 5:
            convertHourTime()
        elif option == 6:
            convertDayTime()
        elif option == 8:
           mode = 1 #switch mode
        elif option == 9:
            break

print("\n\nThank you for using the Time Calculator") #print goodbye message once loop completed
